"
I am BaselineOfBrea, I load the code for the Brea project.
I am a BaselineOf.
"
Class {
	#name : #BaselineOfBrea,
	#superclass : #BaselineOf,
	#category : #BaselineOfBrea
}

{ #category : #baselines }
BaselineOfBrea >> baseline: spec [
	<baseline>

	spec
		for: #common
		do: [ 
			"Dependencies"
			self grafoscopioUtils: spec.
			spec 
				baseline: 'NeoJSON' with: [ spec repository: 'github://svenvc/NeoJSON/repository' ];
				baseline: 'Mustache' with: [ spec repository: 'github://noha/mustache/repository' ]; 
				baseline: 'TaskIt' with: [ spec repository: 'github://noha/taskit:add-all-future' ].

			"Packages"
			spec package: 'Brea' with: [ spec requires:  #('NeoJSON' 'Mustache' 'TaskIt' 'Grafoscopio-Utils') ].
		]
]

{ #category : #baselines }
BaselineOfBrea >> grafoscopioUtils: spec [
	"I load the configuration of this package using a external Gitea repository."
	"While more Git independient providers are implemented in Monticello, I will use Iceberg
	to download the repository and load it from a local directory"	
			
	| location localRepo |
	"Dependencies"
	
	"Local and remote repo definition"
	location := FileLocator localDirectory / 'iceberg' / 'Offray' / 'GrafoscopioUtils'.
	location exists ifFalse: [
		(IceRepositoryCreator new 
			location: location;
			remote: (IceGitRemote url: 'https://code.tupale.co/Offray/GrafoscopioUtils.git');
			createRepository)
		register
	].
	"Package loading"
	localRepo := 'gitlocal://', location fullName.
	Metacello new
		repository: localRepo;
		baseline: 'GrafoscopioUtils';
		load.
	spec baseline: 'GrafoscopioUtils' with: [ spec repository:  localRepo ].
	spec package: 'Grafoscopio-Utils' with: [ spec repository:  localRepo ].

]
