"
I model an Airtable (https://airtable.com/) database (or Base as they call it).
"
Class {
	#name : #Airtable,
	#superclass : #Object,
	#instVars : [
		'id',
		'apiKey'
	],
	#category : #Brea
}

{ #category : #accessing }
Airtable >> apiKey [
	^ apiKey
]

{ #category : #accessing }
Airtable >> apiKey: aString [
	apiKey := aString
]

{ #category : #accessing }
Airtable >> id [
	^ id
]

{ #category : #accessing }
Airtable >> id: aString [
	id := aString
]

{ #category : #'as yet unclassified' }
Airtable >> rawRecords [

	(self id isNil or: [ self apiKey isNil ]) ifTrue: [ ^ self ].
	^ ZnClient new
		url: (self id);
		headerAt: 'Authorization' put: 'Bearer ', (self apiKey);
		get.

]

{ #category : #'as yet unclassified' }
Airtable >> records [

	^ ((NeoJSONReader fromString: (self rawRecords)) at: 'records') 
			select: [ :each | (each at: 'fields') isNotEmpty ]

]
